import 'package:flutter/material.dart';

///动态变化图标
///
class AnimatedColorIcon extends ImplicitlyAnimatedWidget {
  final IconData icon;
  final Color color;
  final double size;

  AnimatedColorIcon({
    this.icon,
    this.color,
    this.size,
    Duration duration = const Duration(milliseconds: 300),
    Curve curve = Curves.easeInOutCubic,
  }) : super(
          duration: duration,
          curve: curve,
        );
  @override
  ImplicitlyAnimatedWidgetState<ImplicitlyAnimatedWidget> createState() =>
      _AniamtedColorIconState();
}

class _AniamtedColorIconState
    extends AnimatedWidgetBaseState<AnimatedColorIcon> {
  ColorTween _colorTween;
  @override
  Widget build(BuildContext context) {
    return Icon(
      widget.icon,
      color: _colorTween.evaluate(animation),
      size: widget.size,
    );
  }

  @override
  void forEachTween(context) {
    _colorTween = context(
      _colorTween,
      widget.color,
      (dynamic value) => ColorTween(begin: value),
    );
  }
}
