import 'package:aku_ui/common_widgets/aku_cupertino_button.dart';
import 'package:aku_ui/common_widgets/aku_material_button.dart';
import 'package:aku_ui/mixins/aku_mixins.dart';
import 'package:flutter/material.dart';

///按钮
class AkuButton extends StatefulWidget {
  @required
  final Widget child;
  final double height;
  final double radius;
  final EdgeInsets padding;
  @required
  final VoidCallback onPressed;
  final Color color;
  AkuButton({
    Key key,
    this.child,
    this.height = 0,
    this.radius = 0,
    this.onPressed,
    this.padding = EdgeInsets.zero,
    this.color = Colors.transparent,
  }) : super(key: key);

  @override
  _AkuButtonState createState() => _AkuButtonState();
}

class _AkuButtonState extends State<AkuButton> with PlatformMixin {
  @override
  Widget build(BuildContext context) {
    return isIOS
        ? AkuCupertinoButton(
            onPressed: widget.onPressed,
            child: widget.child,
            radius: widget.radius,
            minHeight: widget.height,
            padding: widget.padding,
            color: widget.color,
          )
        : AkuMaterialButton(
            onPressed: widget.onPressed,
            child: widget.child,
            radius: widget.radius,
            height: widget.height,
            padding: widget.padding,
            color: widget.color,
          );
  }
}
